
import java.io.* ;

public class PortOutputStream extends OutputStream {
  Port P ;
  ByteArrayOutputStream strm ;

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
  //                                                                     //
  // Constructor.                                                        //
  //                                                                     //
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //

  public PortOutputStream(Port P) {
    this.P = P ;
    strm = new ByteArrayOutputStream() ;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
  //                                                                     //
  // Methods.                                                            //
  //                                                                     //
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //

  public synchronized void write(int b) {strm.write(b) ; }

  public synchronized void write(byte b [], int off, int len) {
    strm.write(b, off, len) ;
  }

  public synchronized void flush() {
    P.send(strm.toByteArray()) ;
    strm.reset() ;
  }
}

